var isDefault;	
var tagService = Components.classes["@mozilla.org/messenger/tagservice;1"]
		.getService(Components.interfaces.nsIMsgTagService);

function init() {
	isDefault = false;
	var tagArray = tagService.getAllTags({});
	var list = document.getElementById("list");
	var keylist = document.getElementById("key");
	for (var i = 0; i < tagArray.length; i++) {
		var taginfo = tagArray[i];
		var item = list.insertItemAt( i, taginfo.tag, taginfo.key );
		item.style.color = taginfo.color;
		keylist.insertItemAt(i,(i+1).toString(),"");
	}	
}

function move(offset) {
	isDefault = false;
	var list = document.getElementById("list");
	var pos = list.selectedIndex;
	if ( (pos == 0 && offset > 0) || ( pos == (list.itemCount -1) && offset < 0) )
		return;
	var label = list.currentItem.label;
	var value = list.currentItem.value;
	var color = list.currentItem.style.color;
	var newpos = pos - offset;
	var item = list.removeItemAt(list.currentIndex);
	var newitem = list.insertItemAt(newpos, label, value);
	newitem.style.color = color;
	list.selectedIndex = newpos;
}
		
function restoreDefault() {
	var tagArray = tagService.getAllTags({});
	tagArray.sort(function(a,b) {
		if (a.key < b.key) //sort string ascending
			return -1
		if (a.key > b.key)
			return 1
		return 0 //default return value (no sorting)
	} );
	var list = document.getElementById("list");
	for (var i = 0; i < tagArray.length; i++) {
		var taginfo = tagArray[i];
		var item = list.getItemAtIndex(i);
		item.label = taginfo.tag;
		item.value = taginfo.key;
		item.style.color = taginfo.color;
	}
	isDefault = true;
}
	
function save() {
	var alphabet = "abcdefghijklmnopqrstuvwxyz";
	var numbers = "0123456789";
	var numberIndex = 0;
	var alphaIndex = 0;
	var list = document.getElementById("list");
	for (var i=0;i<list.itemCount;i++) {
		var item = list.getItemAtIndex(i);
		if (isDefault) 
			tagService.setOrdinalForKey(item.value, "");
		else {
			if (numberIndex < 10) {
				var ordinal = alphabet[alphaIndex] + numbers[numberIndex];
				numberIndex++;
			}
			else {
				alphaIndex++;
				numberIndex = 1;
				var ordinal = alphabet[alphaIndex] + numbers[0];
			}
			tagService.setOrdinalForKey(item.value, ordinal);
		}
	}
}

